//David Little
//SpiroGraph Version 2.0
//Last updated April 4, 2002
//Compiled with MRJ SDK2.1 (compatible with JDK1.1)

import java.awt.*;
import java.awt.print.*;
import java.awt.event.*;
import java.util.*;
import javax.print.*;
import javax.print.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;

public class SpiroGraphApplet extends JApplet implements ActionListener,
														AdjustmentListener, 
														WindowListener{

	final String title = "SpiroGraph 2.0";
	
	static SpiroGraphPanel drawgraph;
	
	JCheckBox auto;
	JCheckBox show;

	JLabel rad1;
	JLabel rad2;
	JLabel pos;
	JLabel vel;
	JLabel res;
	JLabel X;
	JLabel Y;
	JLabel swatch;

	JScrollBar RAD1;
	JScrollBar RAD2;
	JScrollBar POS;
	JScrollBar VEL;
	JScrollBar RES;

	JButton clear;
	JButton draw;
	JButton reset;
	JButton rand;
	JButton print;

	boolean autodraw = true;
	
	MenuBar menubar;
	Menu file;
	Menu options;
	MenuItem quit;
	
	Palette palette;

	JFrame frame;
	SplashPanel splash;

    public void init(){
		//Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();

		setBackground(Color.white);
		//setTitle(title);
		//setVisible(false);
		//setSize(WIDTH, HEIGHT);
		
		getContentPane().add( splash = new SplashPanel( this ) );
		//add( splash = new SplashPanel( this ) );

		frame = new JFrame();
			frame.setVisible(false);
			frame.setSize(675, 600);
			frame.setLocation(0,0);
			frame.setTitle( "SpiroGraph" );
			frame.setResizable(false);

		Container contentpane = frame.getContentPane();
		contentpane.setLayout( new BorderLayout() );

		JPanel east = new JPanel( new BorderLayout() );
//			east.setBorder( BorderFactory.createTitledBorder( east.getBorder(), "Controls", TitledBorder.CENTER, TitledBorder.TOP, new Font( "Helvetica", Font.BOLD, 15) ) );
			east.setBorder( BorderFactory.createTitledBorder( east.getBorder(), "", TitledBorder.CENTER, TitledBorder.TOP, new Font( "Helvetica", Font.BOLD, 15) ) );
//			east.setBorder( BorderFactory.createEtchedBorder(EtchedBorder.RAISED) );

		JPanel eastnorth = new JPanel( new BorderLayout() );
			JPanel north = new JPanel( new GridLayout(12,1,0,0) );
			north.add( rad1 = new JLabel("Radius1: 60",JLabel.LEFT) );
			north.add( RAD1 = new JScrollBar(JScrollBar.HORIZONTAL,60,5,5,155));
			//north.add( new Label("") );
			north.add( rad2 = new JLabel("Radius2: 60",JLabel.LEFT) );
			north.add( RAD2 = new JScrollBar( JScrollBar.HORIZONTAL,60,5,-59,155));
			//north.add( new Label("") );
			north.add( pos = new JLabel("Position: 60",JLabel.LEFT) );
			north.add( POS = new JScrollBar(JScrollBar.HORIZONTAL,60,5,-200,200));
			//north.add( new Label("") );
			north.add( res = new JLabel("Resolution: 100",JLabel.LEFT) );
			north.add( RES = new JScrollBar(JScrollBar.HORIZONTAL,100,10,1,1000));
			//north.add( new Label("") );
			north.add( vel = new JLabel("Velocity: 10",JLabel.LEFT) ); 
			north.add( VEL = new JScrollBar(JScrollBar.HORIZONTAL,10,1,0,11));
			//north.add( new Label("") );
			north.add( auto = new JCheckBox( "Automatic", true));
			north.add( show = new JCheckBox( "Show Circles", true));
		
		eastnorth.add( "North", north );

			Panel south = new Panel( new GridLayout(4,1) );
			south.add( clear = new JButton( "Clear" ) );
			south.add( reset = new JButton( "Reset" ) );
			south.add( draw = new JButton( "Draw" ) );
				draw.setDefaultCapable( true );
				frame.getRootPane().setDefaultButton( draw );
			south.add( rand = new JButton( "Random" ) );
			//south.add( print = new JButton( "Print" ) );
			
		eastnorth.add( "South", south );
		
		east.add( "Center", eastnorth);

		east.add("South", palette = new Palette(6,10,this));
			palette.addColor( new Color(.99f,.99f,.99f), "Chalk" );
			palette.addColor( new Color(.93f,.93f,.93f), "Marble" );
			palette.addColor( new Color(.80f,.80f,.80f), "Soapstone" );
			palette.addColor( new Color(.67f,.67f,.67f), "Concrete" );
			palette.addColor( new Color(.53f,.53f,.53f), "Granite" );
			palette.addColor( new Color(.47f,.47f,.47f), "Flint" );
			palette.addColor( new Color(.33f,.33f,.33f), "Shale" );
			palette.addColor( new Color(.20f,.20f,.20f), "Gabbro" );
			palette.addColor( new Color(.13f,.13f,.13f), "Basalt" );
			palette.addColor( new Color(.00f,.00f,.00f), "Obsidian" );

			palette.addColor( new Color(.45f,.40f,.86f), "Violet Dusk" );
			palette.addColor( new Color(.36f,.53f,.95f), "Sky Blue" );
			palette.addColor( new Color(.38f,.84f,.67f), "Ocean Green" );
			palette.addColor( new Color(.37f,.74f,.44f), "Spring Frost" );
			palette.addColor( new Color(.49f,.51f,.36f), "Mildew" );
			palette.addColor( new Color(.90f,.90f,.35f), "Mustard" );
			palette.addColor( new Color(.99f,.75f,.34f), "Canteloupe" );
			palette.addColor( new Color(.97f,.48f,.34f), "Tulip" );
			palette.addColor( new Color(.85f,.27f,.42f), "Carnation" );
			palette.addColor( new Color(.73f,.34f,.76f), "Orchid" );

			palette.addColor( new Color(.51f,.33f,.82f), "Pale Violet" );
			palette.addColor( new Color(.41f,.46f,.91f), "Evening Blue" );
			palette.addColor( new Color(.36f,.73f,.79f), "Fog" );
			palette.addColor( new Color(.38f,.79f,.56f), "Chlorine" );
			palette.addColor( new Color(.44f,.60f,.37f), "Moss" );
			palette.addColor( new Color(.70f,.71f,.35f), "Olive" );
			palette.addColor( new Color(.99f,.91f,.34f), "Banana" );
			palette.addColor( new Color(.99f,.58f,.34f), "Grape Fruit" );
			palette.addColor( new Color(.94f,.38f,.34f), "Salmon" );
			palette.addColor( new Color(.86f,.33f,.68f), "Grape" );

			palette.addColor( new Color(.35f,.09f,.73f), "Violet" );
			palette.addColor( new Color(.09f,.13f,.80f), "Blue" );
			palette.addColor( new Color(.09f,.38f,.35f), "Seaweed" );
			palette.addColor( new Color(.18f,.55f,.13f), "Clover" );
			palette.addColor( new Color(.55f,.74f,.11f), "Cactus" );
			palette.addColor( new Color(.99f,.92f,.09f), "Lemon" );
			palette.addColor( new Color(.99f,.69f,.09f), "Tangerine" );
			palette.addColor( new Color(.99f,.46f,.09f), "Melon" );
			palette.addColor( new Color(.96f,.25f,.11f), "Red Orange" );
			palette.addColor( new Color(.93f,.09f,.12f), "Red" );

			palette.addColor( new Color(.42f,.09f,.69f), "Royal Violet" );
			palette.addColor( new Color(.27f,.09f,.78f), "Blue Violet" );
			palette.addColor( new Color(.09f,.29f,.51f), "Sea Blue" );
			palette.addColor( new Color(.09f,.46f,.20f), "Pine" );
			palette.addColor( new Color(.36f,.64f,.12f), "Fern" );
			palette.addColor( new Color(.73f,.83f,.10f), "Watercress" );
			palette.addColor( new Color(.99f,.80f,.09f), "Marigold" );
			palette.addColor( new Color(.99f,.57f,.09f), "Orange" );
			palette.addColor( new Color(.98f,.31f,.10f), "Fire" );
			palette.addColor( new Color(.94f,.12f,.11f), "Apple" );

			palette.addColor( new Color(.16f,.10f,.06f), "Sepia" );
			palette.addColor( new Color(.36f,.24f,.14f), "Raw Sienna" );
			palette.addColor( new Color(.55f,.38f,.21f), "Dirt" );
			palette.addColor( new Color(.75f,.52f,.29f), "Tan" );
			palette.addColor( new Color(.80f,.78f,.76f), "Warm Marble" );
			palette.addColor( new Color(.55f,.50f,.45f), "Warm Granite" );
			palette.addColor( new Color(.24f,.22f,.20f), "Warm Shale" );
			palette.addColor( new Color(.76f,.76f,.80f), "Cool Marble" );
			palette.addColor( new Color(.45f,.45f,.55f), "Cool Granite" );
			palette.addColor( new Color(.20f,.20f,.24f), "Cool Shale" );

	    palette.randomColor();

		contentpane.add("East",east);
		contentpane.add("Center", drawgraph = new SpiroGraphPanel(this) );

		JLabel statusbar = new JLabel("");
			//statusbar.setPreferredSize( new Dimension(15,15) );
		contentpane.add("South", statusbar );


		menubar = new MenuBar();
		//setMenuBar(menubar);
		menubar.add(file = new Menu("File"));
			//file.add(print = new MenuItem("Print"));
			//print.setShortcut(new MenuShortcut(KeyEvent.VK_P,false));
			file.add(quit = new MenuItem("Quit"));
			quit.setShortcut(new MenuShortcut(KeyEvent.VK_Q,false));
		//menubar.add(options = new Menu("Options"));

		RAD1.addAdjustmentListener( this );
		RAD2.addAdjustmentListener( this );
		POS.addAdjustmentListener( this );
		VEL.addAdjustmentListener( this );
		RES.addAdjustmentListener( this );
		rand.addActionListener( this );
		clear.addActionListener( this );
		reset.addActionListener( this );
		draw.addActionListener( this );
		//print.addActionListener( this );
		quit.addActionListener( this );
		auto.addActionListener( this );
		show.addActionListener( this );
		frame.addWindowListener( this );

		//randomSettings();
	}

	public void showFrame(){
		frame.setVisible( true );
	}


	public void start(){
		//splash.active = true;
		if ( !frame.isVisible() ) splash.start();
	}

	public void stop(){
		splash.active = false;
		//frame.setVisible( false );
	}


	public void handlePrint(){
/*
		try {
			// Open the image file
			//InputStream is = new BufferedInputStream(new FileInputStream("filename.gif"));
			
			// Find the default service
			//DocFlavor flavor = DocFlavor.INPUT_STREAM.GIF;
			DocFlavor flavor = DocFlavor.BYTE_ARRAY.AUTOSENSE;
			PrintService service = PrintServiceLookup.lookupDefaultPrintService();


			// Create the print job
			DocPrintJob job = service.createPrintJob();
			Doc doc = new SimpleDoc(drawgraph.offImage, flavor, null);

			// Monitor print job events; for the implementation of PrintJobWatcher,
			// see e702 Determining When a Print Job Has Finished
			PrintJobWatcher pjDone = new PrintJobWatcher(job);
    
			// Print it
			job.print(doc, null);
    
			// Wait for the print job to be done
			pjDone.waitForDone();
    
			// It is now safe to close the input stream
			//is.close();

		} catch (PrintException e) {
		}*/			
/*
        PrinterJob printJob = PrinterJob.getPrinterJob();
        printJob.setPrintable(drawgraph);
        if ( printJob.printDialog() ) {
            try {
                printJob.print();
            } catch (Exception ex) {
                ex.printStackTrace();
            }
        }
*/		
/*
	// print out rad1,rad2,position,resolution
	
		PrintJob pj = getToolkit().getPrintJob(new Frame(),"SpiroGraph", null);
		if (pj!=null){		
			Graphics g = pj.getGraphics();
			int H = pj.getPageDimension().height;
			int W = pj.getPageDimension().width;
				
			//Image top = topImage(page);
			//g.drawImage(top,(W-top.getWidth(this))/2,0,this);
			
			Image img = drawgraph.offImage;
		
			int y = img.getHeight(this);
			int x = img.getWidth(this);
			g.drawImage(img,(W-x)/2,(H-y)/2,this);

			g.dispose();
			pj.end();
		}*/
	}
/*	
	class PrintJobWatcher {
        // true iff it is safe to close the print job's input stream
        boolean done = false;
    
        PrintJobWatcher( DocPrintJob job ) {
            // Add a listener to the print job
            job.addPrintJobListener(new PrintJobAdapter() {
                public void printJobCanceled(PrintJobEvent pje) {
                    allDone();
                }
                public void printJobCompleted(PrintJobEvent pje) {
                    allDone();
                }
                public void printJobFailed(PrintJobEvent pje) {
                    allDone();
                }
                public void printJobNoMoreEvents(PrintJobEvent pje) {
                    allDone();
                }
                void allDone() {
                    synchronized (PrintJobWatcher.this) {
                        done = true;
                        PrintJobWatcher.this.notify();
                    }
                }
            });
        }
        public synchronized void waitForDone() {
            try {
                while (!done) {
                    wait();
                }
            } catch (InterruptedException e) {
            }
        }
    }
*/	
	
	public void randomSettings(){
		RAD1.setValue(RAD1.getMinimum()+(int)(Math.random()*(RAD1.getMaximum()-RAD1.getMinimum())));
		rad1.setText("Radius1: " + RAD1.getValue());

		int r = 0;
		RAD2.setMinimum( -RAD1.getValue()+1 );
		while (r==0) r = RAD2.getMinimum()+(int)(Math.random()*(RAD2.getMaximum()-RAD2.getMinimum()));
		RAD2.setValue(r);
		rad2.setText("Radius2: " + r);

		POS.setValue(POS.getMinimum()+(int)(Math.random()*(POS.getMaximum()-POS.getMinimum())));
		pos.setText("Position: " + POS.getValue());

		//RES.setValue(RES.getMinimum()+(int)(Math.random()*(RES.getMaximum()-RES.getMinimum())));
		RES.setValue(RES.getMinimum()+(int)(Math.random()*360));
		res.setText("Resolution: " + RES.getValue());

		VEL.setValue(10);
		vel.setText("Velocity: 10");

		//pick a random color
		palette.randomColor();
		
		drawgraph.thread = new Thread( drawgraph );
		drawgraph.active = false;
		drawgraph.start();
	}
	

	public void actionPerformed( ActionEvent ae ){
		String s = ae.getActionCommand();
		Object obj = ae.getSource();

		if ( s.equals("Draw") && RAD2.getValue()!=0){
			draw.setText( "Pause" );
			drawgraph.n=(double)RES.getValue();
			drawgraph.start();
		} else if ( s.equals("Pause") && RAD2.getValue()!=0 ){
			drawgraph.pause();
			draw.setText( "Resume" );
		} else if ( s.equals("Resume") && RAD2.getValue()!=0 ){	  
			drawgraph.resume();
			draw.setText( "Pause" );
		} else if ( s.equals("Reset") ){
			drawgraph.reset();
			draw.setText( "Draw" );
		} else if (s.equals("Clear")){
			drawgraph.clear();
			drawgraph.repaint();
		} else if ( obj == auto ){
			if ( auto.isSelected() ){
				VEL.setValue(10);
				vel.setText("Velocity: 10");
				show.setSelected( false );
			} else {
				show.setSelected( true );
			}
			drawgraph.repaint();
		} else if ( obj == show ){
			if ( show.isSelected() ){
			} else {
				VEL.setValue(10);
				vel.setText("Velocity: 10");
			}
			drawgraph.repaint();
		} else if ( obj == print ){
			handlePrint();
		} else if (obj == rand){
			if (!drawgraph.active){
				randomSettings();
			}
		} else if (obj == quit){
			System.exit(0);
		}
	}


	public void adjustmentValueChanged(AdjustmentEvent e){
		Adjustable a = e.getAdjustable();
		if (a.equals(RAD1)){
			rad1.setText("Radius1: " + RAD1.getValue());
			int n = RAD2.getValue();
			int m = RAD1.getValue();
			if (n<2-m){
				n=1-m;
				RAD2.setValue(n);
				rad2.setText("Radius2: " + n);
				drawgraph.values[1] = n;
			}
			RAD2.setMinimum(2-m);
			drawgraph.values[0] = RAD1.getValue();
		} else if (a.equals(RAD2)){
			rad2.setText("Radius2: " + RAD2.getValue());
			drawgraph.values[1] = RAD2.getValue();
			if (drawgraph.values[1] < 0) drawgraph.values[3]=-1.0;
			else drawgraph.values[3]=1.0;
		} else if (a.equals(POS)){
			pos.setText("Position: " + POS.getValue());
			drawgraph.values[2] = POS.getValue();
		} else if (a.equals(VEL)){
			vel.setText("Velocity: " + VEL.getValue());
		} else if (a.equals(RES)){
			res.setText("Resolution: " + RES.getValue());
		}
		if ( drawgraph.count==0 || !auto.isSelected() ){
			drawgraph.setCenter();
			drawgraph.setPoint();
			drawgraph.ratio = 1.0 + drawgraph.values[0]/drawgraph.values[1];
			drawgraph.sum = drawgraph.values[0] + drawgraph.values[1] + drawgraph.values[3];
			drawgraph.val2 = drawgraph.values[2];
		}
		drawgraph.repaint();
			
		if ( auto.isSelected() && !drawgraph.thread.isAlive() && drawgraph.count==0 && RAD2.getValue()!=0 && !a.equals(VEL)){
			drawgraph.start();
		} 
	}
		
		
	public void windowClosed(WindowEvent we){
	}

	public void windowOpened(WindowEvent we){
	}

	public void windowIconified(WindowEvent we){
	}

	public void windowDeactivated(WindowEvent we){
	}

	public void windowClosing(WindowEvent we){
		splash.start();
	}

	public void windowActivated(WindowEvent we){
	}

	public void windowDeiconified(WindowEvent we){
	}
}
